#Persistent
#SingleInstance
#NoEnv
#NoTrayIcon

; Ini file
WindowStyleIni := "WindowStyle.ini"

; Column Titles (base valuable names)
GRID_TITLE   = #|hwnd|pid|title|class|exe|MinMax|top|left|width|height|Style|ExStyle
; Culumns as Integer
COL_AS_INT   = #|hwnd|pid|top|left|width|height
; Columns auto fitted 
COL_AUTO_FIT = #|hwnd|pid|class|exe|top|left|width|height|Style|ExStyle

DEFAULT_SELECTED   = class
IGNORE_FILTER_TYPE = #|top|left|width|height
DONT_SHOW_DETAIL   = # ;|Style|ExStyle


Gosub, InitValue
Gosub, InitGui
Gosub, InitSubGui
OnMessage(0x200, "WM_MOUSEMOVE")


return


InitGui:
	buff =
	GUi, 1:Default
	Gui, +Resize +MinSize500x200
	Gui, Add, Button, x0 y0 w0 h0 gDefaultButtonAction Default Hidden
	Gui, Add, Text, x0 yp+0 w0 h0, Search &Type
	Gui, Add, DropDownList, vFilterType w80
	Gui, Add, Text, x+0 yp+0 w0 h0, Search &Pattern
	Gui, Add, Edit, x+0 yp+0 vFilterPattern w200
	Gui, Add, Button, x+2 yp+0 gDoSearch vBtn1,  &Investigate
	GUi, Add, CheckBox, x+4 yp+5 vDHW -multi,    Detects &Hidden
	GUi, Add, CheckBox, x+4 yp+0 vRegExp -multi, &RegExp
	Gui, Add, StatusBar, 0x100 vStatusBar1
	Gui, Add, ListView, r20 w400 x0 y+10 vListView1 gListViewEvent AltSubmit, %GRID_TITLE%
	Loop, PARSE, GRID_TITLE, |
	{
		If(RegExMatch(A_LoopField ,COL_AS_INT)) {
			LV_ModifyCol(A_Index, "INTEGER")
		}
		If (!RegExMatch(A_LoopField, IGNORE_FILTER_TYPE))
			GuiControl,, FilterType, % A_LoopField . (A_LoopField = DEFAULT_SELECTED ? "||" : "")
	}
	GuiControlGet, b, Pos, Btn1
	Gui, Show, w600 h300
	return

GuiSize:
	GuiControlGet, l, Pos, ListView1
	GuiControlGet, s, Pos, StatusBar1
	w := A_GuiWidth - lx
	h := A_GuiHeight - ly - sh
	GuiControl,Move, ListView1, w%w% h%h%
	return

GuiClose:
	ExitApp



DefaultButtonAction:
	GuiControlGet, f, FocusV
	Gosub,% (f = "ListView1") ? "ShowSelectedItem" : "DoSearch"
	GuiControl,Focus,%f%
	return

ListViewEvent:
	if (A_GuiEvent != "DoubleClick")
		return
ShowSelectedItem:
	row := LV_GetNext(0)
	if (row < 1)
		return
	clipBuffer = [Window Infomation]`n
	Loop, PARSE, GRID_TITLE, |
	{
		if (RegExMatch(A_LoopField, DONT_SHOW_DETAIL))
			continue
		if (A_LoopField = "exe")
			exe := GetProcessExeNameNT(pid)
		else
			LV_GetText(%A_LoopField%, row, A_Index)
		clipBuffer .=A_LoopField "`t" %A_LoopField% "`n" 
	}
	; GUI2
	Gui, 2:Default
	Loop, PARSE, GRID_TITLE, |
	{
		If (RegExMatch(A_LoopField, DONT_SHOW_DETAIL))
			continue
		GuiControl,, Edit2_%A_Index%, % %A_LoopField%
	}
	
	SetFormat, Integer, H
	Loop, PARSE, $names, |
	{
		clipBuffer .= "[Window " A_LoopField "]`n"
		name := A_LoopField
		unknown := %A_LoopField%
		Loop, PARSE, $Names[%name%], |
		{
			if (%name% & code[%A_LoopField%] > 0) {
				GuiControl, , %A_LoopField%, 1
				GuiControl, +cBlue, %A_LoopField%
				clipBuffer .= "`t+" code[%A_LoopField%] " (" A_LoopField ")`n"
				unknown -= (unknown & code[%A_LoopField%])
			} else {
				GuiControl, , %A_LoopField%, 0
				GuiControl, +cDefault, %A_LoopField%
			}
		}
		
		GuiControl,, Unknown[%A_LoopField%], %unknown%
	}
	Gui, Show
	return

DoSearch:
	SetBatchLines, 1ms
	Gui, Submit, NoHide
	Gui, +OwnDialogs
	if (RegExp) {
		RegExMatch("", FilterPattern)
		if (ErrorLevel) {
			MsgBox, %ERRORLEVEL%
			return
		}
	}
	GUi, +Disabled
	GuiControl,Disable1, Btn1
	switch := dhw ? "On" : "Off"
	DetectHiddenWindows, %switch%
	WinGet,list, List
	GuiControl,-Redraw,ListView1
	LV_Delete()
	Loop, %list% {
		hwnd := list%A_Index%
		WinInvest(hwnd, pid, title, class, exe, minmax, x,y,w,h, style, exStyle)
		if (RegExp ? RegExMatch(%FilterType%, FilterPattern) : InStr(%FilterType%, FilterPattern))
			LV_Add("", A_Index, hwnd, pid, title, class, exe, minmax, x,y,w,h, style, exStyle)
	}
	SB_SetText(LV_GetCount() " hits  /  total " list)
	GuiControl,Disable0, Btn1
	Loop, PARSE, GRID_TITLE, |
		If(A_LoopField = FilterType || InStr(COL_AUTO_FIT, A_LoopField) > 0)
			LV_ModifyCol(A_Index, "AutoHdr")
	GuiControl,Focus,ListView1
	GuiControl,+Redraw,ListView1
	GUi, -Disabled
	return

WinInvest(hwnd, ByRef pid, ByRef title, ByRef class, ByRef exe, ByRef minmax, ByRef x,ByRef y,ByRef w,ByRef h, ByRef style, ByRef exStyle) {
	WinGetTitle, title, ahk_id %hwnd%
	WinGEtClass, class, ahk_id %hwnd%
	WinGetPos, x, y, w, h, ahk_id %hwnd%
	WinGet, minmax, MinMax, ahk_id %hwnd%
	WinGet, pid, PID, ahk_id %hwnd%
	WinGet, exe, ProcessName, ahk_id %hwnd%
	minmax := (minmax == -1) ? "Min" : (minmax == 1) ? "Max" : "Normal"
	WinGet, style, Style,  ahk_id %hwnd%
	WinGet, exStyle, ExStyle,  ahk_id %hwnd%
}


InitSubGui:
	Gui, 2:+LabelSubGui +ToolWindow ;+Owner1
	Gui, 2:Default
	Gui, Add, Text, x10,Basic Information
	Loop, PARSE, GRID_TITLE, |
	{
		If (RegExMatch(A_LoopField, DONT_SHOW_DETAIL))
			continue
		Gui, Add, Text, x10 y+4 , %A_LoopField%:
		Gui, Add, Edit, x70 yp-2 vEdit2_%A_Index% w330 ReadOnly
		GuiControlGet, p, POS, Edit2_%A_Index%
	}
	x:=10,y := py + ph + 2
	if ($names) {
		maxY := 0, maxX := 0
		Loop, PARSE, $names, |
		{
			Gui, Add, Text, x%x% y%y%, &%A_LoopField%:
			Loop, PARSE, $names[%A_LoopField%], |
			{
				Gui, Add, CheckBox, x%x% y+2 v%A_LoopField%, %A_LoopField%
				GuiControlGet, p, POS, %A_LoopField%
				maxY := ((py + ph) > maxy) ? py + ph : maxY
				maxX := ((px + pw) > maxX) ? px + pw : maxX
			}
			x := maxX + 20
			maxX%A_Index% := maxX
		}
		x := 10, y := maxY + 6
		Loop, PARSE, $names, |
		{
			Gui, Add, Text, x%x% y%y%, Unknown:
			x += 70
			Gui, Add, Edit, x%x% yp-3 w110 readonly vUnknown[%A_LoopField%]
			x := maxX%A_Index% + 20
		}
	} else {
		Gui, Add, Text, x10 cRed, if "%WindowStyleIni%" exists, you can get more Info!
	}
	Gui, Add, Button, x80 y+10 w100 gCopyToClip, &Copy
	Gui, Add, Button, x+30 yp+0 w100 gCloseDlg  , e&Xit
	Gui, Show, Hide, Window Details
	return

CopyToClip:
	clipboard := clipBuffer
	return

SubGuiClose:
SubGuiEscape:
CloseDlg:
	clipBuffer =
	tooltip
	Gui, Hide
	return


WM_MOUSEMOVE(wParam,lParam,msg,hwnd) {
	if (A_Gui != 2)
		tooltip
	else
		ShowTip(A_GuiControl)
}

InitValue:
	IfNotExist, %WindowStyleIni%
		return
	$names = Style|ExStyle
	errors := ""
	Loop, PARSE, $names, |
	{
		if (!ReadIni($Names[%A_LoopField%], "Names", A_LoopField))
			continue
		str .= "|" A_LoopField
		Loop, PARSE, $Names[%A_LoopField%], |
		{
			ReadIni(code[%A_LoopField%], "Code", A_LoopField)
			ReadIni(help[%A_LoopField%], "Help", A_LoopField)
		}
	}
	if (errors) {
		MsgBox, Data load error(s) Found!%errors%
	}
	StringTrimLeft, $names, str, 1
	return

ReadIni(ByRef var, sectionName, keyName) {
	global WindowStyleIni, errors
	IniRead, value, %WindowStyleIni%, %sectionName%, %keyName%
	if (value == "ERROR") {
		errors .= "`n[" sectionName "] " keyName
		return false
	}
	var := value
	if (sectionName = "help")
		StringReplace, var, var, \n, `n, ALL
	return true
}


ShowTip(styleName) {
	global
	static lastName
	if (InStr(styleName, "WS_") != 1) {
		if (lastName != styleName)
			tooltip
	} else if (lastName != styleName && help[%styleName%])
		Tooltip, % "[" styleName "] " code[%styleName%]  "`n" help[%styleName%]
	lastName := styleName
	return 
}

HexToUpper(hex) {
	StringUpper, hex, hex
	StringReplace, hex, hex, 0X, 0x
	return hex
}



;-------------------------------------------------------
; vZXIDw肵Ďst@CpX𓾂
;    ΏہF NTn /  AHK v1.0.34ȍ~
;       in  pid vZXID
;       ߂l : st@CpX
;-------------------------------------------------------
GetProcessExeNameNT(pid)
{
;   QlF http://cgi19.plala.or.jp/lukewarm/news/2005_05.html#14
;   (قڂ̂܂)

    hModule=0
    dwNeed=0
    l=0
    max:=VarSetCapacity(s,256)

    ; vZX̃nho
    hProcess := DllCall("OpenProcess", Int,0x001F0FFF, Int,0, Int,pid, Int)

    ; ̃vZX̑SẴW[̃Xg̍ŏ1擾
    ; BOOL EnumProcessModules(HANDLE hProcess, MODULE *lphModule, DWORD cb, LPDWORD lpcbNeeded);
    if(DllCall("psapi\EnumProcessModules", Int,hProcess, IntP,hModule, Int,4, UIntP,dwNeed, Int))
    {
        ; DWORD GetModuleFileNameEx(HANDLE hProcess, HMODULE hModule, LPTSTR FileName, DWORD FileNameSize);
        l:=DllCall("psapi\GetModuleFileNameExA", Int,hProcess, Int,hModule, Str,s, Int,max, Int)
    }
    StringLeft,s,s,l

    ; J߂
    DllCall("psapi\CloseProcess", Int,hProcess)
    return s
}

